<?php
/* ---- DHW Warmwasserscript ---- */

// Logging und weitere Infos Initialsieren
include "eh_global.ips.php";
$ds->setname("heizung_wp");
$ds->Log("?  ".str_pad(IPS_GetName($_IPS['SELF']), 80, "=", STR_PAD_RIGHT)."\n");

$TEMP_NORM = 45; // Normale Speichertemperatur
$TEMP_HIGH = 50; // erhhte Speichertemperatur (bei viel PV)
$TEMP_LOW  = 40; // niedrige Speichertemperatur

$DHW_LOW_MORNING = 20;

$HEAT_START_HOUR = 13;
$HEAT_START_MINUTE  = 25; // nicht 30, da hier der job erst luft
$HEAT_STOP_HOUR  = 18;

/* ========= IST WERTE ERMITTELN ========================================================*/
$h             = date('G'); // Aktuelle Uhrzeit
$temp_dhw      = getValue(57904);
$temp_dhw_target = getValue(15898);
$fc            = json_decode(GetValue(55335),true);
$mode_current  = getValue(34876);
$temp_dhw_K    = getValue(25827);
$wp_heat       = getValue(43136);
$wp_on         = getValue(19422);


/* PV Forecast die nchsten 2 Stunden --------------------- */
$pve = 0;
foreach($fc["hourly"] as $k =>$fh){
    if($fh["day"] == 0 && ($fh["hour"] == $h || $fh["hour"] == ($h + 1) ) ){
        $pve += $fh["pv_estimate"];
    } 
}

// Ziel Temperatur definieren
$temp_dhw_target_new = $TEMP_NORM;
$bat = getvalue(11245);
if($pve > 4 && $h > 12 && $bat > 90){
    $temp_dhw_target_new = $TEMP_HIGH;
    $ds->log("DHW: PV erwartet: $pve kWh. Temperatur wird erhht auf $temp_dhw_target_new C.");
}

/* ========= ZEITFENSTER UND ZIELTEMPERATUREN DEFINIEREN ============================*/
$do_dhw = false;

/* Samstag und Sonntag morgens Warmwasser fr Kinder */
if(date('w') == 6 || date('w') == 0 && $h > 9 && $h < $HEAT_START_HOUR){
    $do_dhw = true;
    $temp_dhw_target_new = $TEMP_LOW;
}

/* --- MORGENS - ERWRMEN, wenn zu niedrig ---*/
if($h >= 4 && $h < 7 && $temp_dhw < $DHW_LOW_MORNING ){
    $do_dhw = true;
    $temp_dhw_target_new = $TEMP_LOW;
}


// Heat - Start vorziehen, wenn Batterie voll ist.
$bat = getValue(11245);
if(($bat > 70 || date('w') == 6 || date('w') == 0 ) && $h >= 9 && $h < 21){
    $do_dhw = true;
    $HEAT_START_HOUR    = date("G");
    $HEAT_START_MINUTE = 30;
}

/* --- MITTAGSZEIT DHW und HEIZEN ---*/
$start_time = mktime($HEAT_START_HOUR, $HEAT_START_MINUTE,0,date("m"),date("d"),date("Y"));
$stop_time  = mktime($HEAT_STOP_HOUR, 0,0,date("m"),date("d"),date("Y"));
if(time() > $start_time && time() < $stop_time){
    $do_dhw = true;
}
if( time() > $stop_time) $do_dhw = false;


$ds->log("DHW: WW-Temp: $temp_dhw");
$ds->log("DHW: WW-Soll: $temp_dhw_target_new");

if($temp_dhw_target != $temp_dhw_target_new){
    $ds->log("DHW: Target Temp ($temp_dhw_target_new) wird gesetzt");
    RequestAction(55503, $temp_dhw_target_new);       
}       

/* ========= AKTIVIEREN WENN NOTWENDIG =================================================*/
if($do_dhw && ( $temp_dhw <= ($temp_dhw_target_new  + $temp_dhw_K ) )){
    $ds->dhw = $do_dhw;    
    $ds->log("DHW: AN");
 
}else{
    $ds->log("DHW: AUS");
    $ds->dhw = $do_dhw;    
}
$ds->save();

#echo  $ds->log();