<?php
include "eh_global.ips.php";
$ds->setname("heizung_wp");
$ds->Log("?  ".str_pad(IPS_GetName($_IPS['SELF']), 80, "=", STR_PAD_RIGHT));

/* Das Haus wird mehr geheizt, wenn wir viel Strom haben,
   und / oder der COP gut ist oder die Temperatur drauen warm ist.*/

/*- CONFIG ---------------------------------------------------------------*/
$COPid    = 56427; // COP der WP
$PVOverID = 32184; // Variable in der der aktuelle PV Berschuss gelesen wird

$PVOvermin = 1000;    // Minimaler Strom berschuss der vorhanden sein muss
$COPmin    = 4;       // Minimaler COP ab dem berschussheizen aktiviert wird.
//or
$TempOutmin = 6;      // Minimale Auentemperatur fr berschussheizen

$TempOutMax = GetValue(51201);     // Maximale Auentemperatur fr berschussheizen
$hourMin   = 11;      // Uhrzeit nach der berschussheizen aktiviert werden soll
$hourMax   = 16;      // Uhrzeit nach der berschussheizen nicht mehr aktiviert werden soll
$AVGTime   = 30 * 60; // 30 Minuten, Rckwirkend Werte bercksichtigen
$Delay_ON  = 60 * 120;// wie lange muss sie aus sein, beovor sie an geht
$Delay_OFF = 60* 60;   // Wie lange soll sie mindestens laufen
$DelayCnt  = 3;       // 3x muss nderung erfolgen fr Ausschalten.
/*- CONFIG ---------------------------------------------------------------*/


################################################################################
# 1. Durschnittliche Auentemperatur
# 2. Durschnittlicher PV Ertrag ermitteln
################################################################################
# AVG Werte ERmitteln ======================================================
$TempOut = getValue(59388);
/* AVG - COP ----------------------------------------*/
$t2 = time();
$t1 = $t2 - $AVGTime;
$w = AC_GetAggregatedValues( 26472,
                             $COPid,
                             5,
                             $t1,
                             $t2,
                             1
                          );
$cnt = 0;
$COPavg=0;
foreach($w as $we){
    $cnt++;
    $COPavg  += $we["Avg"];
}
$COPavg = $COPavg / $cnt;

/* AVG - PV Ertrag ----------------------------------------*/
$w = AC_GetAggregatedValues( 26472,
                             $PVOverID,
                             5,
                             $t1,
                             $t2,
                             1
                        );
$cnt = 0;
$PVOveravg=0;
foreach($w as $we){
    $cnt++;
    $PVOveravg  += $we["Avg"];
}
$PVOveravg = round( $PVOveravg / $cnt);

if( ($COPavg > $COPmin || $TempOutmin < $TempOut && $COPavg > 3 || $COPavg == 0) && $PVOveravg > $PVOvermin ){
    $do = true;
}else{
    $do = false;
}
$ds->log("OVH: Temp-Out:   $TempOut");
$ds->log("OVH: COP-AVG:        $COPavg");
$ds->log("OVH: PV Berschuss:  $PVOveravg");
$ds->log("OVH: => Overheat:    $do");

################################################################################
# Auentemperatur Check 
################################################################################
if($do && $TempOutMax < $TempOut){
    $ds->log("OVH: berschussheizen deaktiviertn, Auentemperatur > $TempOutMax C");
    $do = false;
}

################################################################################
# Nur im von Oktober - Mrz und nur bis max Uhr 
################################################################################
$month = intval(date("m"));
$hour  = intval(date("G"));
if($month > 4 && $month < 9 )             $do = false;
if($hour < $hourMin || $hour >= $hourMax) $do = false;

$id = CreateVariableByName($_IPS['SELF'],"Overheat",   0);
$do_old = getValue($id);

// ANSCHALTEN -------------------------------------------------------
if($do && !$do_old){
    $ds->DelayONCnt++;
    if(time() - $Delay_ON > $ds->ts_OFF && $ds->DelayONCnt > $DelayCnt){
        SetValue($id, $do);
        $ds->ts_ON = time();
        $ds->DelayONCnt = 0;
        $ds->log("=> Overheat wird ANGESCHALTET");
    }else{
        $ds->log("=> Delay noch nicht erreicht. Keine nderung");
    }
}

// AUSSCHALTEN -------------------------------------------------------
if(!$do && $do_old){
    $ds->DelayOFFCnt++;
    if(time() - $Delay_OFF > $ds->ts_ON && $ds->DelayOFFCnt > $DelayCnt){
        SetValue($id, $do);
        $ds->ts_OFF = time();
        $ds->DelayOFFCnt = 0;
        $ds->log("=> Overheat wird AUSGESCHALTET");
    }else{
        $ds->log("=> Delay noch nicht erreicht. Keine nderung");
    }
}

$ds->save();